(** clauses for typing the reserved symbols of the signature *)

open Abstract;;

open Clause;;

(** typing of declared constants *)
val typing_cst : Symbols.eva_symbol_list -> clause list

(** typing of the the intruders name *)
val typing_intruder : clause

(** typing of declared values (ie other constants) *)
val typing_val : Symbols.eva_symbol_list -> clause list

(** typing of the empty list *)
val typing_emptylist : clause

(** typing of CONS *)
val typing_cons : clause

(** typing of APP *)
val typing_app : Symbols.eva_symbol_list -> clause list

(** typing of the VANILLA
  in this settings, VANILLA is a (constant) function symbol. *)
val typing_vanilla : clause list

(** typing the union of symmetric and assymetric algorithms *)
val typing_algo : clause list

(** typing of CRYPT, variable algo *)
val typing_crypt_algo : clause

(** the abstract spec should not contain EVA_SIGN *)

(** typing of coercion symbol P *)
val typing_P : clause

(** typing of coercion symbol A *)
val typing_A : clause

(** typing of coercion symbol SA *)
val typing_SA : clause

(** typing of coercion symbol AA *)
val typing_AA : clause

(** typing of coercion symbol U *)
val typing_U : Symbols.eva_symbol_list -> clause list

(* list of clauses for declaration of the symbols of the signature *)
val horn_signature : Symbols.eva_symbol_list -> clause list

